//+------------------------------------------------------------------+
//|                                                   MovingLRv3.mq4 |
//|                                                           Candid |
//|                                                 candid.110mb.com |
//+------------------------------------------------------------------+
#property copyright "Candid"
#property link      "candid.110mb.com"
 
#property indicator_chart_window
#property indicator_buffers 3

#property indicator_color1 Blue
#property indicator_color2 DodgerBlue
#property indicator_color3 DodgerBlue
#property indicator_width1 2
#property indicator_width2 1
#property indicator_width3 1
 
extern int Frame = 61;             //  
extern double W = 3.0;          //  
extern int Shift = 0;              //  
extern int Sample = 0;          //  

string OName = "MovingLRv3";   

int PreBars;
datetime BarTime;

int bFrame;            //  
int eFrame;            //  
int bSample;           //  
int eSample;           //  
int MinBars;           // 

bool FirstFrame;       //

int pos,pos0;          // 
double Y[];            // 
double YY[];           // 
int FPtr;              // 
double SumY;           //
double SumXY;          //
double SumYY;          //
double A;              //
double B;              //
double rmsY;           //
int F1;
double K1,K2,K3;          //

int BTime,ETime;

double Buf[];
double UBuf[];
double DBuf[];

//double Lwma_Sma[];


int init() {

   if (Frame < 3) {
     Alert("MovingLRv3:  Frame    2");
     return(0);
   }  
   PreBars = 0;
   BarTime = 0;
   MinBars = Shift+Frame+1;
   ArrayResize(Y,Frame);
   ArrayResize(YY,Frame);

   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,Buf);
   
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,UBuf);

   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2,DBuf);

   F1 = Frame-1;
 
   K1 = Frame*(Frame*Frame-1);
   K1 = 12.0/K1;
   K2 = Frame*(Frame+1);
   K3 = (Frame+Frame-1)/K2;
   K3 = K3+K3;
   K2 = 6.0/K2;
   
   ObjectCreate(OName,OBJ_TREND,0,0,0,0);

   return(0);
}

int deinit() {
  ObjectDelete(OName);
  return(0);
}
 
//+------------------------------------------------------------------+
//| Custom indicator reset function                                  |
//+------------------------------------------------------------------+
int Reset() {
  FirstFrame = true;
  eSample = Shift+Frame;
  bSample = eSample+Sample-1;
  if (bSample > Bars-1 || Sample == 0) bSample = Bars-1;
  return(bSample);
}

int start() {  
  if (Bars == PreBars) return(0);
  if (Bars < MinBars) {
    Alert("MovingLRv3:    ");
    return(0);
  }  
  if (Bars-PreBars == 1 && BarTime==Time[1]) bSample = Frame+Shift;
  else bSample = Reset();
  PreBars = Bars;  
  BarTime=Time[0];
//  BTime = GetTickCount();
  for(bFrame = bSample; bFrame >= eSample; bFrame--) {
    eFrame = bFrame-F1;
    if (FirstFrame) {
      FirstFrame = false;
      Y[F1] = 0.5*(High[bFrame]+Low[bFrame]);
      SumY=Y[F1];
      SumXY=F1*Y[F1];
      YY[F1] = Y[F1]*Y[F1];
      SumYY=YY[F1];
      for (pos = eFrame; pos < bFrame; pos++) {
        FPtr = pos-eFrame;
        Y[FPtr] = 0.5*(High[pos]+Low[pos]);
        YY[FPtr] = Y[FPtr]*Y[FPtr];
        SumY = SumY + Y[FPtr];
        SumYY = SumYY + YY[FPtr];
        SumXY = SumXY + FPtr*Y[FPtr];
      }
      FPtr++;
    } else {  //  if (FirstFrame)
      SumY = SumY - Y[FPtr];
      SumYY = SumYY - YY[FPtr];
      SumXY = SumXY + SumY - F1*Y[FPtr];
      Y[FPtr] = 0.5*(High[eFrame]+Low[eFrame]);
      SumY = SumY + Y[FPtr];
      YY[FPtr] = Y[FPtr]*Y[FPtr];
      SumYY = SumYY + YY[FPtr];
      FPtr--;
      if (FPtr < 0) FPtr = F1;
    }  // else {  //  if (FirstFrame) 
    A = K1*SumXY - K2*SumY;
    B = K3*SumY - K2*SumXY;

    rmsY = SumYY - A*SumXY - B*SumY;
    if (rmsY < 0.0) {
      Print("MovingLRv3:  ");
      continue;
    }
    rmsY = MathSqrt(rmsY/(Frame-2));

    Buf[eFrame] = B;
    UBuf[eFrame] = B+W*rmsY;
    DBuf[eFrame] = B-W*rmsY;
    
  }  // for(bFrame = bSample; bFrame < eSample; bFrame++)
//  ETime = GetTickCount();
//  Print("MovingLRv3: ",ETime-BTime,"ms");

  
  ObjectSet(OName,OBJPROP_TIME1,Time[bFrame]);
  ObjectSet(OName,OBJPROP_PRICE1,A*(Frame-1)+B);
  ObjectSet(OName,OBJPROP_TIME2,Time[eFrame]);
  ObjectSet(OName,OBJPROP_PRICE2,B);

/*
  BTime = GetTickCount();
  for( int i = Bars - 1; i >= 0; i-- ) 
  {  
      Lwma_Sma[ i ] = 3* iMA( NULL, 0, Frame, Shift, MODE_LWMA, PRICE_MEDIAN, i ) - 
                      2* iMA( NULL, 0, Frame, Shift, MODE_SMA,  PRICE_MEDIAN, i ); 
  }
  ETime = GetTickCount();
//  Print("LRMA: ",ETime-BTime,"ms");
*/  
  return(0);
}